package at.jku.students;

import at.jku.ssw.List;
import at.jku.ssw.Iterator;
import at.jku.ssw.ListNode;
import at.jku.ssw.DotMaker;

public class LinkedList extends List {

  ListNode head = null;

  public void add(int index, Object value) {
    int pos = 0;
    ListNode p = head, prev = null;
    while (p != null && pos < index) {
      pos++;
      prev = p;
      p = p.next;
    }
    if (pos == index) {
      ListNode n = new ListNode(value);
      n.next = p;
      if (prev == null) {
        head = n;
      } else {
        prev.next = n;
      }
    } else {
      throw new IndexOutOfBoundsException();
    }
  }
  
  public void add(Object value) {
    add(size(), value);
  }
  
  public Object get(int index) {
    if (index < 0) {
      throw new IndexOutOfBoundsException();
    }
    ListNode p = head;
    int pos = 0;
    while (p != null && pos < index) {
      pos++;
      p = p.next;
    }
    if (p != null) {
      return p.value;
    } else {
      throw new IndexOutOfBoundsException();
    }
  }

  public int size() {
    ListNode p = head;
    int size = 0;
    while (p != null) {
      size++;
      p = p.next;
    }
    return size;
  }

  public Iterator iterator() {
    return new LinkedListIterator(head);
  }

  public int indexOf(Object value) {
    int index = 0;
    ListNode p = head;
    while (p != null) {
      if (p.value.equals(value)) {
        return index;
      }
      index++;
      p = p.next;
    }
    return -1;
  }

  public Object remove(int index) {
    throw new UnsupportedOperationException();
  }

  public String makeDot() {
    return DotMaker.makeDotForLinkedList(head);
  }
}
